<script type="text/javascript">
	/*globals RED */
	RED.nodes.registerType('Storage Definition', {
		category: 'config',
		color: '#fdeea2',
		defaults: {
			name: {required:false},
			action: {value: "blockStorage",required:true},
			blocksize: {value:4096,required:true},"blocksize-type": {value:"num"},
			fileName: {value:"payload",required:true},"fileName-type": {value:"str"}
		},
		inputs: 1,
		outputs: 2,
		icon: "database-setting-icon.png",
		align: 'left',
		paletteLabel: "Storage Definition",
		inputLabels: "Message In",
		outputLabels: ["Message Out","Error"],
		label: function () {
			return this.name || "Storage Definition "+this.action;
		},
		oneditprepare: function() {
			const node=this;
			$("#node-input-name").val(node.name);
			node.properties=[];
			node.editors=[];
			const actions={
				blockStorage:{label:"Block Storage",show:["fileName","blocksize"],args:[]}
			};
			const baseDiv=$("#node-inputDynamicBase");
			function defineProperty(property,...types) {
				const element=$('<div/>',{ "class": "form-row form-row-http-in-"+property.name+" hide" }).append(
    				 	$('<label for="node-input-'+property.name+'" style="white-space: nowrap"><i class="fa fa-'+(property.icon||'bookmark')+'"></i> '+property.label+'</label>'),
					);
				element.appendTo(baseDiv);
				node.properties.push(property.name);
				if(types[0]=="edit") {
					element.append($('<div style="height: 250px; min-height:150px;" class="node-text-editor" id="node-input-'+property.name+'-editor"></div>'));
					node.editors[property.name] = RED.editor.createEditor({
   						id: 'node-input-'+property.name+'-editor',
   						mode: 'ace/mode/'+property.mode||"text",
   						value: node[property.name]||property.default
					});
				} else {
					const inputNode=$('<input type="text" id="node-input-'+property.name+'"/>').val(node[property.name]);
					const typeNode=$('<input type="hidden" id="node-input-'+property.name+'-type"/>');
					element.append([inputNode,typeNode]);
					const typeValue=node[property.name+"-type"];
					if(typeValue) typeNode.val(typeValue);
					$("#node-input-"+property.name).typedInput({
	  					type:typeValue||types[0],
    					types:types,
    					typeField: "#node-input-"+property.name+"-type"
					});
				}
			}
			defineProperty({name:"fileName"	,label:"File Name"		,icon:"crosshairs"},"str","global");
			defineProperty({name:"blocksize",label:"Block Size"		,icon:"tachometer"},"num","global");

			const options=Object.keys(actions).reduce((previousValue,property)=>previousValue.concat({value:property,label:actions[property].label}),
				[]);
			const actionNode=$("#node-input-action");
			actionNode.typedInput({
    			types: [{
            		value: "actionType",
            		options: options
				}]
			});
			actionNode.change(function() {
				action=$(this).val();
				node.args=[];
				node.properties.forEach(property=>$(".form-row-http-in-"+property).hide());
				const actionDef=actions[action];
				node.args=actionDef.args;
				node.args.forEach(property=>$(".form-row-http-in-"+property).show());
				actionDef.show.forEach(property=>$(".form-row-http-in-"+property).show());

			}).change();
		},
		oneditsave: function() {
			const node=this;
			Object.keys(node.editors).forEach(property=>{
				const editor=node.editors[property];
				node[property]=editor.getValue();
	    		editor.destroy();
    			delete editor;
			})
			node.name=$("#node-input-name").val()
		},
		oneditcancel: function() {
			const node=this;
			Object.keys(node.editors).forEach(property=>{
				const editor=node.editors[property];
    			editor.destroy();
    			delete editor;
			});
		},
		resizeRule: function(file,newWidth) {
		}
	});
</script>

<script type="text/x-red" data-template-name="Storage Definition">

	<div class="form-row">
		<label for="node-input-name"><i class="fa fa-tag"></i> Name </label>
		<input type="text" id="node-input-name" placeholder="Name">
	</div>
	<div class="form-row">
		<label for="node-input-action" style="white-space: nowrap"><i class="fa fa-cog"></i> Type</label>
		<input type="text" id="node-input-action">
    </div>
	<div id="node-inputDynamicBase"/>
</script>

<script type="text/x-red" data-help-name="Storage Definition">
	<p>
	Storage Definition
	</p>
	<h3>Inputs</h3>
	<dl class="message-properties">
		<dt>msg <span class="property-type">topic</span></dt>
		<dd>incoming message with topic</dd>
		<dt>msg <span class="property-type">payload</span></dt>
		<dd></dd>
	</dl>
</script>